#!/bin/bash
##
# Postconf
# Versin v.0.1 
# Juan Miguel Jimnez Fernndez
#Modificado del script original Realizado por Fernando Hernndez y Juan Francisco Fernndez
# TO-DO
	#Mirar script de sophos donde discrimina segn versiones.
#
# Chequeamos si es el primer arranque tras clonacin:

# Con esto obtenemos la resolucin por pantalla:
#system_profiler SPDisplaysDataType | grep Resolution

if [ -f /iConfigurame ]
then
	if [ ! -f /var/root/FechaRestauracion.log ]; then # Si no existe est recien restaurado
		date >/var/root/FechaRestauracion.log
	fi
	#Establecemos variables
	kickstart="/System/Library/CoreServices/RemoteManagement/ARDAgent.app/Contents/Resources/kickstart"
	#systemsetup="/usr/sbin/systemsetup" no vlido para 10.4
	hoy=`date +%Y.%m.%d-%H.%M.%S`
	. /etc/rc.common

	echo $hoy >> /var/log/postconf.log

	# chequeamos la red y esperamos a tener ip
	CheckForNetwork
	while [ "${NETWORKUP}" != "-YES-" ]
	do
		sleep 5
		NETWORKUP=
		CheckForNetwork
	done

	# obtenemos ip4 y cambiamos el nombre del equipo
	IP=`ifconfig en0 inet | grep "inet" | cut -c 7-19`
	IP4=`echo $IP | cut -d'.' -f4 `
	IP60=60 # Ip mxima del aula 1, actualmente es menor, pero la ip del equipo de prueba es 59
	if  (("$IP4" <  "$IP60")) ;  then
		nombre=bbaa-lt1-$IP4
	else
		nombre=bbaa-lt2-$IP4
	fi
	scutil --set ComputerName $nombre
	scutil --set LocalHostName $nombre
	scutil --set HostName $nombre
	hostname $nombre	
	# Falta los nombres de samba, parece que 10.4 no lo tiene en plist como 10.6 mirar en 10.7

	echo $nombre >> /var/log/postconf.log

	mount -a >> /var/log/postconf.log
	
	# Se crean los enlaces para descargas y documentos a la particin de datos
	mkdir -p /Volumes/DATOS/Documentos/Music 2>> /var/log/postconf.log
	mkdir /Volumes/DATOS/Documentos/Movies 2>> /var/log/postconf.log
	mkdir /Volumes/DATOS/Documentos/Pictures 2>> /var/log/postconf.log
	mkdir /Volumes/DATOS/Descargas 2>> /var/log/postconf.log

	#Copiamos los contenidos de las carpetas de usuario a DATOS conservando atributos
	ditto -rsrc "/Users/alumnos/Documents" "/Volumes/DATOS/Documentos" 2>> /var/log/postconf.log
	ditto -rsrc "/Users/alumnos/Music" "/Volumes/DATOS/Documentos/Music" 2>> /var/log/postconf.log
	ditto -rsrc "/Users/alumnos/Pictures" "/Volumes/DATOS/Documentos/Pictures" 2>> /var/log/postconf.log
	ditto -rsrc "/Users/alumnos/Movies" "/Volumes/DATOS/Documentos/Movies" 2>> /var/log/postconf.log
	rm -r /Users/alumnos/Descargas 2>> /var/log/postconf.log
	rm -r /Users/alumnos/Documents 2>> /var/log/postconf.log
	rm -r /Users/alumnos/Movies 2>> /var/log/postconf.log
	rm -r /Users/alumnos/Music 2>> /var/log/postconf.log
	rm -r /Users/alumnos/Pictures 2>> /var/log/postconf.log

	# Asignamos a alumnos la particin de Datos
	chown -R alumnos /Volumes/Datos 2>> /var/log/postconf.log
	ln -s /Volumes/Datos/Descargas /Users/alumnos/Descargas 2>> /var/log/postconf.log
	ln -s /Volumes/Datos/Documentos /Users/alumnos/Documents 2>> /var/log/postconf.log
	ln -s /Volumes/Datos/Documentos/Movies /Users/alumnos/Movies 2>> /var/log/postconf.log
	ln -s /Volumes/Datos/Documentos/Pictures /Users/alumnos/Pictures 2>> /var/log/postconf.log
	ln -s /Volumes/Datos/Documentos/Music /Users/alumnos/Music 2>> /var/log/postconf.log
	
	#fijamos el arranque en el volumen 2
	bless  --device /dev/disk0s2 --setBoot 2>> /var/log/postconf.log

	$kickstart -configure -allowAccessFor -specifiedUsers
	$kickstart -activate -configure -access -on -users "RD" -privs -all -restart -agent
	#$systemsetup -setnetworktimeserver cronos.uma.es no vlido para 10.4
	
	 vsdbutil -d /Volumes/Datos
	#Instalamos el antivirus (Modificar en un futuro para que descargue de la pgina del antivirus)
	cd /var/root/ESCOSX
	installer -pkg 'Sophos Anti-Virus.mpkg' -target /
	cp /var/root/ESCOSX/com.sophos.sau.plist /Library/Preferences/
	# borramos el archivo "flag" de que hay que realizar la postconfiguracin
	rm /iConfigurame
	#Esperamos 30 segundos y reiniciamos
	sleep 30
	reboot
fi
# bloqueamos escritorio, fondo, dock, etc del usuario alumno (por si ha sido desbloqueado)
chflags uchg /Users/alumnos/Library/Preferences/com.apple.desktop.plist
chflags uchg /Users/alumnos/Library/Preferences/com.apple.dock.plist
chflags uchg /Users/alumnos/Desktop
